## mingw-w64-gimp3-2.99.18-4.src.tar.zst

=== meson_options.txt ===
# Build properties
option('ansi',              type: 'boolean', value: false,  description: 'Turn on strict ansi')
option('enable-console-bin',type: 'boolean', value: true,   description: 'Build a console-only binary which does not link GTK')
option('win32-debug-console',type:'boolean', value: true,   description: 'Open a console when starting the program')
option('enable-multiproc',  type: 'boolean', value: true,   description: 'Support for multiple processors')
option('profiling',         type: 'boolean', value: false,  description: 'Enable profiling')
option('windows-installer', type: 'boolean', value: false,  description: 'Generate files needed for the Windows installer')

option('relocatable-bundle', type: 'combo', value: 'platform-default',
                             description: 'build with resources considered bundled under the same prefix',
                             choices: [ 'yes', 'no', 'platform-default' ])

option('shmem-type',        type: 'combo',   value: 'auto', description: 'Shared memory transport type',
                                             choices: [ 'none', 'sysv', 'posix', 'win32', 'auto' ])

option('build-id',          type: 'string',  value: 'unknown', description: 'Unique string used to define your build')
option('revision',          type: 'integer', value: 0,    description: 'Revision increment for a package')
option('check-update',      type: 'combo', value: 'platform-default',
                            description: 'GIMP will look up new version availability on startup',
                            choices: [ 'yes', 'no', 'platform-default' ])

option('bug-report-url',    type: 'string',  value: '',   description: 'URL used by the debug dialog to report bugs')
option('gimpdir',           type: 'string',  value: '',   description: 'Change default gimpdir from ~/.config/GIMP/2.9 to ~/.config/DIR/2.9 (if relative), or to DIR (if absolute)')
option('icc-directory',     type: 'string',  value: '',   description: 'Path to default color profiles for this system')
option('directx-sdk-dir',   type: 'string',  value: '',   description: 'Prefix where the DirectX SDK is installed(optional)')
option('with-sendmail',     type: 'string',  value: '',   description: 'Use Sendmail instead of Xdg-email')

option('win32-32bits-dll-folder', type: 'string',  value: '32/bin', description: 'alternative folder with 32-bit versions of DLL libraries on Windows')
option('libunwind',         type: 'boolean', value: true, description: 'Build with libunwind for backtrace')
option('libbacktrace',      type: 'boolean', value: true, description: 'Build with libbacktrace support')

# Features

option('enable-default-bin',type: 'feature', value: 'auto', description: 'Install unversioned symlinks pointing to versioned executables')
option('aa',                type: 'feature', value: 'auto', description: 'AA plugin')
option('alsa',              type: 'feature', value: 'auto', description: 'Alsa support in midi input controller')
option('appdata-test',      type: 'feature', value: 'auto', description: 'Validate the appdata file')
option('cairo-pdf',         type: 'feature', value: 'auto', description: 'Cairo-pdf support')
option('fits',              type: 'feature', value: 'auto', description: 'Support for loading/exporting FITS images')
option('ghostscript',       type: 'feature', value: 'auto', description: 'Ghostscript support')
option('gudev',             type: 'feature', value: 'auto', description: 'Gudev support')
option('heif',              type: 'feature', value: 'auto', description: 'HEIF support')
option('ilbm',              type: 'feature', value: 'auto', description: 'Amiga IFF support')
option('jpeg2000',          type: 'feature', value: 'auto', description: 'Jpeg-2000 support')
option('jpeg-xl',           type: 'feature', value: 'auto', description: 'JPEG XL support')
option('mng',               type: 'feature', value: 'auto', description: 'Mng support')
option('openexr',           type: 'feature', value: 'auto', description: 'Openexr support')
option('openmp',            type: 'feature', value: 'auto', description: 'OpenMP support')
option('print',             type: 'boolean', value: true,   description: 'Print support')
option('webkit-unmaintained',type: 'boolean', value: false,  description: 'Help browser and webpage plugins (unmaintained)')
option('webp',              type: 'feature', value: 'auto', description: 'Webp support')
option('wmf',               type: 'feature', value: 'auto', description: 'Wmf support')
option('xcursor',           type: 'feature', value: 'auto', description: 'Xcursor support')
option('xpm',               type: 'feature', value: 'auto', description: 'XPM support')
option('headless-tests',    type: 'feature', value: 'auto', description: 'Use xvfb-run/dbus-run-session for UI-dependent automatic tests')

option('can-crosscompile-gir', type: 'boolean', value: false, description: 'GIR is buildable even if crosscompiling')

option('gi-docgen',         type: 'feature', value: 'auto', description: 'Build developer documentation (uses gi-docgen)')
option('g-ir-doc',          type: 'boolean', value: false,  description: 'Build developer documentation for introspected API')

option('linux-input',       type: 'feature', value: 'auto', description: 'Linux input event controller module')
option('vector-icons',      type: 'boolean', value: true,   description: 'Use vector icons rather than raster ones')

option('vala',              type: 'feature', value: 'auto', description: 'Build VAPI and Vala plugins')
option('javascript',        type: 'feature', value: 'auto', description: 'Install Javascript plug-ins')
option('lua',               type: 'feature', value: 'auto', description: 'Install Lua plug-ins')
option('python',            type: 'feature', value: 'auto', description: 'Install Python 3 plug-ins')

=== PKGBUILD ===
# Maintainer: Alexey Pavlov <Alexpux@gmail.com>

_realname=gimp3
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=2.99.18
pkgrel=4
pkgdesc="GNU Image Manipulation Program (mingw-w64)"
arch=('any')
mingw_arch=('mingw32' 'mingw64' 'ucrt64' 'clang64' 'clangarm64')
url="https://www.gimp.org/downloads/devel/"
msys2_repository_url="https://gitlab.gnome.org/GNOME/gimp"
msys2_references=(
  'aur: gimp-devel'
  "cpe: cpe:/a:gimp:gimp"
)
license=('spdx:GPL-3.0-or-later AND LGPL-3.0-or-later')
depends=("${MINGW_PACKAGE_PREFIX}-aalib"
         "${MINGW_PACKAGE_PREFIX}-appstream-glib"
         "${MINGW_PACKAGE_PREFIX}-atk"
         "${MINGW_PACKAGE_PREFIX}-babl"
         "${MINGW_PACKAGE_PREFIX}-brotli"
         "${MINGW_PACKAGE_PREFIX}-cairo"
         "${MINGW_PACKAGE_PREFIX}-cfitsio"
         "${MINGW_PACKAGE_PREFIX}-drmingw"
         "${MINGW_PACKAGE_PREFIX}-gegl"
         "${MINGW_PACKAGE_PREFIX}-gettext-runtime"
         "${MINGW_PACKAGE_PREFIX}-gexiv2"
         "${MINGW_PACKAGE_PREFIX}-ghostscript"
         "${MINGW_PACKAGE_PREFIX}-gi-docgen"
         "${MINGW_PACKAGE_PREFIX}-glib2"
         "${MINGW_PACKAGE_PREFIX}-glib-networking"
         "${MINGW_PACKAGE_PREFIX}-graphviz"
         "${MINGW_PACKAGE_PREFIX}-gtk3"
         "${MINGW_PACKAGE_PREFIX}-headers-git"
         "${MINGW_PACKAGE_PREFIX}-iso-codes"
         "${MINGW_PACKAGE_PREFIX}-json-c"
         "${MINGW_PACKAGE_PREFIX}-json-glib"
         "${MINGW_PACKAGE_PREFIX}-lcms2"
         "${MINGW_PACKAGE_PREFIX}-lensfun"
         "${MINGW_PACKAGE_PREFIX}-libarchive"
         "${MINGW_PACKAGE_PREFIX}-libheif"
         "${MINGW_PACKAGE_PREFIX}-libiff"
         "${MINGW_PACKAGE_PREFIX}-libjxl"
         "${MINGW_PACKAGE_PREFIX}-libilbm"
         "${MINGW_PACKAGE_PREFIX}-libmng"
         "${MINGW_PACKAGE_PREFIX}-libmypaint"
         "${MINGW_PACKAGE_PREFIX}-libspiro"
         "${MINGW_PACKAGE_PREFIX}-libwebp"
         "${MINGW_PACKAGE_PREFIX}-libwmf"
         "${MINGW_PACKAGE_PREFIX}-luajit"
         "${MINGW_PACKAGE_PREFIX}-lua51-lgi"
         "${MINGW_PACKAGE_PREFIX}-maxflow"
         "${MINGW_PACKAGE_PREFIX}-mypaint-brushes"
         "${MINGW_PACKAGE_PREFIX}-openexr"
         "${MINGW_PACKAGE_PREFIX}-pango"
         "${MINGW_PACKAGE_PREFIX}-poppler"
         "${MINGW_PACKAGE_PREFIX}-poppler-data"
         "${MINGW_PACKAGE_PREFIX}-python-gobject"
         "${MINGW_PACKAGE_PREFIX}-shared-mime-info"
         "${MINGW_PACKAGE_PREFIX}-suitesparse"
         "${MINGW_PACKAGE_PREFIX}-vala"
         "${MINGW_PACKAGE_PREFIX}-xpm-nox")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-meson"
             "${MINGW_PACKAGE_PREFIX}-gettext-tools"
             "${MINGW_PACKAGE_PREFIX}-gobject-introspection"
             "${MINGW_PACKAGE_PREFIX}-libxslt"
             "${MINGW_PACKAGE_PREFIX}-qoi")
source=("https://download.gimp.org/pub/gimp/v2.99/gimp-${pkgver}.tar.xz"
        0001-clang-rc-files-fix.patch
        0002-skip-test-env.patch
        0003-dont-install-external-files.patch
        )
sha256sums=('8c1bb7a94ac0d4d0cde4d701d8b356387c2ecd87abbd35bbf7d222d40f6ddb6e'
            '54b3abc136b78fd2ae9b7d2acd202fb91bf3b6c248b131f1629ca50ef2493fbe'
            '511a2a969d1ff3254b4f2453cdfbc3a86a60e2379adf9f6ed5735454a45ef6ee'
            'd0181cc5e68ade9f42869c0f147deec7da15cc9c0a7d9b78862ef02fce081688')

apply_patch_with_msg() {
  for _patch in "$@"
  do
    msg2 "Applying ${_patch}"
    patch -Nbp1 -i "${srcdir}/${_patch}"
  done
}

prepare() {
  cd "${srcdir}/gimp-${pkgver}"
  apply_patch_with_msg \
    0001-clang-rc-files-fix.patch \
    0002-skip-test-env.patch \
    0003-dont-install-external-files.patch
}

build() {
  mkdir -p "${srcdir}"/build-${MSYSTEM} && cd "${srcdir}"/build-${MSYSTEM}

  CFLAGS+=" -Wno-incompatible-pointer-types" \
  MSYS2_ARG_CONV_EXCL="--prefix=" \
  ${MINGW_PREFIX}/bin/meson.exe setup \
    --buildtype=plain \
    --auto-features=enabled \
    --prefix=${MINGW_PREFIX} \
    -Daa=disabled \
    -Dalsa=disabled \
    -Dappdata-test=disabled \
    -Ddirectx-sdk-dir="${MINGW_PREFIX}" \
    -Denable-multiproc=true \
    -Dg-ir-doc=false \
    -Dgi-docgen=disabled \
    -Dgudev=disabled \
    -Dheadless-tests=disabled \
    -Djavascript=disabled \
    -Dlinux-input=disabled \
    -Dxcursor=disabled \
    -Dwin32-debug-console=true \
    -Denable-default-bin=disabled \
    ../gimp-${pkgver}

  ${MINGW_PREFIX}/bin/meson.exe compile
}

package() {
  cd "${srcdir}"/build-${MSYSTEM}
  ${MINGW_PREFIX}/bin/meson.exe install --destdir="${pkgdir}"

  # Adjust the python interpreter path
  sed -e "s|\=.*|\=python3w.exe|g" -i "${pkgdir}${MINGW_PREFIX}"/lib/gimp/2.99/interpreters/pygimp.interp
  sed -e "s|::python3|::python3w.exe|g" -i "${pkgdir}${MINGW_PREFIX}"/lib/gimp/2.99/interpreters/pygimp.interp

  # enable-default-bin uses symlinks, so disable it and copy manually instead
  for _prog in "${pkgdir}${MINGW_PREFIX}/bin/"*-2.99.exe; do
    _baseprog=$(basename "$_prog")
    install -Dm755 "${_prog}" \
      "${pkgdir}${MINGW_PREFIX}/bin/${_baseprog//-2.99/}"
  done

  rm -f "${pkgdir}${MINGW_PREFIX}/lib/gimp/2.99/modules/*.dll.a"

  install -Dm644 "${srcdir}/gimp-${pkgver}/LICENSE" "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE"
  install -Dm644 "${srcdir}/gimp-${pkgver}/COPYING" "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/COPYING"
}
